using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Bson.Serialization;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Monitoring.Maintenance.Updates;

[Route(Navigation.Monitoring.Maintenance.Updates.Index)]
public partial class Index
{
    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;

    private TableContainer<ViewModel>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override void OnInitialized()
    {
        Title = $"Monitoring » Maintenance » Updates｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Monitoring", href: Navigation.Monitoring.Index));
        Breadcrumbs.Add(new BreadcrumbItem("Maintenance", href: Navigation.Monitoring.Maintenance.Index));
        Breadcrumbs.Add(new BreadcrumbItem("Updates", href: "#", true));
    }

    private async Task<TableData<ViewModel>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostUpdateEntity>.Filter.Eq(p => p.Pending, true);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostUpdateEntity>.Filter.Regex(x => x.Name, regex) |
                    Builders<HostUpdateEntity>.Filter.Regex(x => x.Date, regex);
            }

            var query = Database.HostUpdate()
                .Aggregate()
                .Match(filter)
                .Lookup("host", "_host", "_id", "hosts")
                .Match(Builders<BsonDocument>.Filter.SizeGt("hosts", 0))
                .Group(new BsonDocument
                {
                    { "_id", "$_host" },
                    { "host", new BsonDocument("$first", new BsonDocument("$first", "$hosts")) },
                    { "updates", new BsonDocument("$addToSet", "$_id") }
                })
                .Lookup("customer", "host._customer", "_id", "customers")
                .Project(new BsonDocument
                {
                    { "_id", 0 },
                    { "host", "$host" },
                    { "customer", new BsonDocument("$first", "$customers") },
                    { "updates", 1 },
                    { "updates_size", new BsonDocument("$size", "$updates") }
                })
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Ascending("host"),
                        "Customer" => Builders<BsonDocument>.Sort.Ascending("customer"),
                        "Updates" => Builders<BsonDocument>.Sort.Ascending("updates_size"),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Host" => Builders<BsonDocument>.Sort.Descending("host"),
                        "Customer" => Builders<BsonDocument>.Sort.Descending("customer"),
                        "Updates" => Builders<BsonDocument>.Sort.Descending("updates_size"),
                        _ => null
                    },
                    _ => Builders<BsonDocument>.Sort.Descending("updates_size")
                });

            var countResult = await query.Count().FirstOrDefaultAsync(default);
            var itemResult = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default);

            return new TableData<ViewModel>()
            {
                TotalItems = countResult is null ? 0 : (int)countResult.Count,
                Items = itemResult.Select(x => BsonSerializer.Deserialize<ViewModel>(x))
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<ViewModel>();
        }
    }

    [BsonIgnoreExtraElements]
    public class ViewModel
    {
        [BsonElement("host")]
        public HostEntity? Host { get; set; }

        [BsonElement("customer")]
        public CustomerEntity? Customer { get; set; }

        [BsonElement("updates_size")]
        public int? Updates { get; set; }
    }
}